"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withErrorBoundary = void 0;
const react_1 = __importDefault(require("react"));
const ErrorBoundary_1 = require("./ErrorBoundary");
/**
 * React HOC for creating ErrorBoundaryWrapper component.
 * @param params.renderBoundary
 * @param params.onDidCatch
 * @returns
 */
const withErrorBoundary = (params) => (WrappedComponent) => {
    const { renderBoundary, onDidCatch } = params;
    return (props) => {
        return (react_1.default.createElement(ErrorBoundary_1.ErrorBoundary, { renderBoundary: renderBoundary, onDidCatch: onDidCatch },
            react_1.default.createElement(WrappedComponent, Object.assign({}, props))));
    };
};
exports.withErrorBoundary = withErrorBoundary;
